#include <cstdio>
#include <cstdlib>
#include <vector>
#include <array>

extern std::vector<std::array<long long, 2>> police_thief(std::vector<int> A, std::vector<int> B, std::vector<int> D, std::vector<int> P, std::vector<int> V1, std::vector<int> T, std::vector<int> V2);

void my_assert(bool x){
	if(!x){
		puts("Wrong input");
		exit(0);
	}
}

int main(){
	int N, Q;
	my_assert(scanf("%d %d", &N, &Q) == 2);
	std::vector<int> A(N - 1), B(N - 1), D(N - 1), P(Q), T(Q), V1(Q), V2(Q);
	for(int i = 0; i < N - 1; i++){
		my_assert(scanf("%d %d %d", &A[i], &B[i], &D[i]) == 3);
	}
	for(int i = 0; i < Q; i++){
		my_assert(scanf("%d %d %d %d", &P[i], &V1[i], &T[i], &V2[i]) == 4);
	}
	std::vector<std::array<long long, 2>> C = police_thief(A, B, D, P, V1, T, V2);
	if((int)C.size() != Q){
		puts("Wrong size");
		return 0;
	}
	for(int i = 0; i < Q; i++) printf("%lld %lld\n", C[i][0], C[i][1]);
	return 0;
}